# 
# Try to find CUDPP  library  
# (see http://gpgpu.org/)
# Once run this will define: 
# 
# Adapted from http://dside.dyndns.org/webbzr/normxcorr/trunk/annotate/25/dict_hw/cmake/FindCUDPP.cmake?remember=26
#
# CUDPP_FOUND
# CUDPP_INCLUDE_DIR 
# CUDPP_LIBRARY
# CUDPP_LINK_DIRECTORIES
#

FIND_PATH(CUDPP_INCLUDE_DIR cudpp.h
   ${CUDPP_ROOT_DIR}/cudpp/include
   ${CUDPP_ROOT_DIR}/include
)

FIND_LIBRARY(CUDPP_LIBRARY
  NAMES cudpp cudpp64 cudpp32
  PATHS 
     ${CUDPP_ROOT_DIR}/lib
     ${CUDPP_ROOT_DIR}/cudpp/lib
)

IF(CUDPP_LIBRARY)
  IF (CUDPP_INCLUDE_DIR)

    # OK, found all we need
    SET(CUDPP_FOUND TRUE)
    GET_FILENAME_COMPONENT(CUDPP_LINK_DIRECTORIES ${CUDPP_LIBRARY} PATH)
    
  ELSE (CUDPP_INCLUDE_DIR)
    MESSAGE("CUDPP include dir not found. Set CUDPP_ROOT_DIR (either as an environment variable or by passing -D CUDPP_ROOT_DIR=/path/to/cudpp to cmake) to find it.")
  ENDIF(CUDPP_INCLUDE_DIR)
ELSE(CUDPP_LIBRARY)
  MESSAGE("CUDPP include dir not found. Set CUDPP_ROOT_DIR (either as an environment variable or by passing -D CUDPP_ROOT_DIR=/path/to/cudpp to cmake) to find it.")
ENDIF(CUDPP_LIBRARY)


MARK_AS_ADVANCED(
  CUDPP_INCLUDE_DIR
  CUDPP_LIBRARY
  CUDPP_LINK_DIRECTORIES
)
